package com.zksy.controller.info;

import cn.hutool.core.date.DateTime;
import com.zksy.info.domain.EEnterpriseInfo;
import com.zksy.info.service.EEnterpriseInfoService;
import com.zksy.property.domain.AHouseType;
import com.zksy.property.service.AHouseTypeService;
import com.zksy.utils.AjaxResult;
import com.zksy.utils.ExcelExportUtil;
import com.zksy.utils.ExcelImportUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Arrays;

/**
 * @author Administrator
 * @version 1.0
 * @project enterprise-assets-service
 * @description 企业基本信息控制层
 * @date 2025/6/24 14:33:13
 */
@RestController
@RequestMapping("/enterpriseInfo")
@Api(tags = "企业基本信息",description = "企业基本信息desc")
public class EEnterpriseInfoController {
    @Autowired
    private EEnterpriseInfoService service;
    @GetMapping("/findByPage")
    @ApiOperation(value = "企业基本信息查询分页")
    public AjaxResult findByPage(long pageNum, long pageSize, String enterpriseName){
        return AjaxResult.success(service.findByPage(pageNum, pageSize, enterpriseName));
    }
    @GetMapping("/getEnterpriseInfoList")
    @ApiOperation(value = "查询企业基本信息")
    public AjaxResult getEnterpriseInfoList(String enterpriseName){
        return AjaxResult.success(service.getEnterpriseInfoList(enterpriseName));
    }
    @GetMapping("/getById/{id}")
    @ApiOperation(value = "根据Id查询企业基本信息")
    public AjaxResult getById(@PathVariable String id){
        return AjaxResult.success(service.getById(id));
    }
    @PostMapping("/save")
    @ApiOperation(value = "企业基本信息保存")
    public AjaxResult save(@RequestBody  EEnterpriseInfo houseType) {
        return service.save(houseType) ? AjaxResult.success(houseType) : AjaxResult.error("保存失败");
    }
    @PostMapping("/update")
    @ApiOperation(value = "企业基本信息修改")
    public AjaxResult update(@RequestBody  EEnterpriseInfo houseType) {
        houseType.setUpdateTime(LocalDateTime.now());
        return service.updateById(houseType) ? AjaxResult.success(houseType) : AjaxResult.error("修改失败");
    }
    @PostMapping("/deleteBatch")
    @ApiOperation(value = "企业基本信息删除")
    public AjaxResult delete(@RequestBody String[] ids) {
        return service.removeBatchByIds(Arrays.asList(ids)) ? AjaxResult.success("删除成功") : AjaxResult.error("删除失败");
    }
    @PostMapping("/importData")
    @ApiOperation(value = "导入数据")
    public AjaxResult importData(MultipartFile file) {
        return AjaxResult.success(service.saveOrUpdateBatch(ExcelImportUtil.importExcel(file, EEnterpriseInfo.class)));
    }
    @GetMapping("/exportData")
    @ApiOperation(value = "导出数据")
    public void exportData(HttpServletResponse response,String enterpriseName) {
        ExcelExportUtil.exportExcel(response,service.getEnterpriseInfoList(enterpriseName), EEnterpriseInfo.class, "企业基本信息","企业基本信息");
    }

}
